package org.beliaj.knots.diagram.impl;

import java.util.*;

import org.beliaj.knots.diagram.ILine;
import org.beliaj.knots.diagram.IPoint;


/**
 *  .
 */
class Point implements IPoint{
	
	final String myName;
	
	/**
	 *   X.
	 */
	private int myX;
	
	/**
	 *   Y.
	 */
	private int myY;
	
	/**
	 *  ,   .
	 *   .
	 */
	private LinkedList<ILine> myLines = new LinkedList<ILine>();
	
	List<ILine> getLines(){
		return this.myLines;
	}

	/**
	 * .
	 *    .
	 * @param x
	 * @param y
	 */
	Point(int x, int y, int i) {
		this.myX = x;
		this.myY = y;
		this.myName = "P" + i;
	}

	/**
	 *  equals.
	 */
	public boolean equals(Object obj){
		if (! (obj instanceof Point)){
			return false;
		}
		
		return (this == obj);
	}

	/**
	 *    .
	 * @return   
	 */
	public int getX() {
		return myX;
	}

	/**
	 *    .
	 * @param x   
	 */
	void setX(int x) {
		this.myX = x;
	}

	/**
	 *    .
	 * @return   
	 */
	public int getY() {
		return myY;
	}

	/**
	 *    .
	 * @param y   
	 */
	void setY(int y) {
		this.myY = y;
	}
	
	/**
	 *  .
	 *     ,   .
	 * @param line 
	 */
	void assignLine(Line line){
		if (this.myLines.size() < 2){
			//    ,   
			this.myLines.add(line);
		} else {
			//   ,   
			throw new LineException("The point "
					+ this.getX()
					+ " "
					+ this.getY()
					+ " already has two incident lines.");
		}
		
		//        
	}
	
	/**
	 *  .
	 * @param line ,   
	 */
	void removeLine(Line line){
		this.myLines.remove(line);
	}
	
	public String toString(){
		return this.myName + ": " + "( " + this.myX + ", " + this.myY + " )";
	}
	
	void move(int i, int j) {
		this.myX = i;
		this.myY = j;
		
	}

	public boolean canConnect() {
		return (this.getLines().size() < 2);
	}

	public List<ILine> getLine() {
		return Collections.unmodifiableList(this.myLines);
	}
	
}