package org.beliaj.knots.painters;

import java.awt.Color;

import javax.swing.JLabel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.beliaj.knots.diagram.IKnotDiagram;
import org.beliaj.knots.simple.SimpleKnot;

public class PolynomViewer {

	private JLabel myStatusLabel;
	private IKnotDiagram myDiagram;
	private SimpleKnot mySimpleKnot = null;

	public PolynomViewer(IKnotDiagram knotDiagram, JLabel label) {
		this.myDiagram = knotDiagram;
		this.myStatusLabel = label;
	}
	
	public void displayInStatusBar(String str){
		this.myStatusLabel.setText("<html><blockquote>" + str + "</blockquote></html>");
	}
	
	public void clearStatusBar(){
		this.myStatusLabel.setText("");
	}

	public void viewJonesPolynom() {
		if (this.mySimpleKnot == null){
			this.mySimpleKnot = new SimpleKnot(this.myDiagram);
			this.mySimpleKnot.addChangeListener(new SimpleChangeListener());
		}
		this.displayInStatusBar(this.mySimpleKnot.getJonesInHTML());
	}
	
	private class SimpleChangeListener  implements ChangeListener{

		public void stateChanged(ChangeEvent e) {
			PolynomViewer.this.clearStatusBar();
		}
		
	}

}
