package org.beliaj.knots.painters.impl;

import java.awt.event.MouseEvent;

import javax.swing.event.ChangeEvent;

import org.beliaj.knots.diagram.IPoint;
import org.beliaj.knots.painters.IEnum;
import org.beliaj.knots.painters.Actor;

class PointActor extends Actor {
	
	IPoint myCurrentPoint = null;

	/**
	 * 
	 */
	private final PaintDiagramClient client;

	/**
	 * @param client
	 */
	PointActor(PaintDiagramClient client) {
		this.client = client;
	}

	public void mousePressed(MouseEvent e) {
		this.myCurrentPoint = this.client.myDiagram.addPoint(this.client.fromRealXToOur(e.getX()),
				this.client.fromRealYToOur(e.getY()));
		this.client.mySelectedPoints.add(this.myCurrentPoint);
		e.getComponent().repaint();
	} 

	public void mouseDragged(MouseEvent e) {
		int x = e.getX();
		int y = e.getY();
		
		if (e.getComponent().getHeight() - this.client.myPointDiam < e.getY()){
			y = e.getComponent().getHeight() - this.client.myPointDiam;
		}
		
		if (e.getComponent().getWidth() - this.client.myPointDiam < e.getX()){
			x = e.getComponent().getWidth() - this.client.myPointDiam;
		}
		
		if (e.getY() < this.client.myPointDiam){
			y = this.client.myPointDiam;
		}
		
		if (e.getX() < this.client.myPointDiam){
			x = this.client.myPointDiam;
		}
		
		if (this.myCurrentPoint != null){
			this.client.myDiagram.movePoint(this.myCurrentPoint,
				this.client.fromRealXToOur(x),
				this.client.fromRealYToOur(y));
		}
		
		e.getComponent().repaint();
	}
	
	public void mouseReleased(MouseEvent e){
		this.myCurrentPoint = null;
		this.client.mySelectedPoints.clear();
		e.getComponent().repaint();
	}

	@Override
	public boolean isActionPossible() {
		return true;
	}

	@Override
	public IEnum getActionCode() {
		return ActionEnum.ADD_POINT;
	}
	
}
