package org.beliaj.knots.simple;

import org.beliaj.knots.diagram.*;

public class SimpleIntersection {
	
	private IIntersection myParent;
	String myName;
	private int fUpNumber = 0;
	private int fDownNumber = 2;
	private int sUpNumber = 1;
	private int sDownNumber = 3;
	private SimpleIntersection[] myNeighbours = new SimpleIntersection[4];
	private int[] myNeighbourPoints = new int[4];
	private int mySignum;
	
	public SimpleIntersection(IIntersection ii, int count){
		this.myParent = ii;
		this.myName = "SI"+count;
		this.countSignumAndAll();
	}
	
	public IIntersection getParent(){
		return this.myParent;
	}

	public int getFNumber(ILine line) {
		if (line.equals(this.myParent.getUpLine())){
			return fUpNumber;
		} else {
			return fDownNumber;
		}
	}

	public void set(int toWat, SimpleIntersection si, int siNumber) {
		this.myNeighbours[toWat] = si;
		this.myNeighbourPoints[toWat] = siNumber;
		
	}

	public int getSNumber(ILine line) {
		if (line.equals(this.myParent.getUpLine())){
			return sUpNumber;
		} else {
			return sDownNumber;
		}
	}
	
	private void countSignumAndAll(){
		int upFX = this.myParent.getUpLine().getFPoint().getX();
		int upFY = this.myParent.getUpLine().getFPoint().getY();
		int upSX = this.myParent.getUpLine().getSPoint().getX();
		int upSY = this.myParent.getUpLine().getSPoint().getY();
		
		int downFX = this.myParent.getDownLine().getFPoint().getX();
		int downFY = this.myParent.getDownLine().getFPoint().getY();
		int downSX = this.myParent.getDownLine().getSPoint().getX();
		int downSY = this.myParent.getDownLine().getSPoint().getY();
		
		upSX -= upFX;
		upSY -= upFY;
		downFX -= upFX;
		downSX -= upFX;
		downFY -= upFY;
		downSY -= upFY;
		
		downFY = -downFX*upSY + downFY*upSX;
		downSY = -downSX*upSY + downSY*upSX;
		
		//System.out.println("count "+this.myName+" downFY "+downFY+" downSY "+downSY);
		if (downFY > 0){
			this.fDownNumber = 2;
			this.sDownNumber = 3;
			this.mySignum = -1;
		} else {
			this.fDownNumber = 3;
			this.sDownNumber = 2;
			this.mySignum = 1;
		}
	}
	
	public int getSignum(){
		return this.mySignum;
	}
	
	//  2!
	//  0 + 2  1 + 3
	public int connectAType(){
		

		int result = 0;
		
		if (this.myNeighbours[0].equals(this)){
			if (this.myNeighbourPoints[0] == 2){
				result++;
				
				if (this.myNeighbours[3].equals(this)){
					result++;
				} else {
					this.myNeighbours[1].set(this.myNeighbourPoints[1], this.myNeighbours[3], this.myNeighbourPoints[3]);
					this.myNeighbours[3].set(this.myNeighbourPoints[3], this.myNeighbours[1], this.myNeighbourPoints[1]);
					
				}
				
				// cjnnect others
			} else if (this.myNeighbours[2].equals(this)){
				result++;
				return result;
			} else {
				this.myNeighbours[1].set(this.myNeighbourPoints[1], this.myNeighbours[2], this.myNeighbourPoints[2]);
				this.myNeighbours[2].set(this.myNeighbourPoints[2], this.myNeighbours[1], this.myNeighbourPoints[1]);
			}
		} else if (this.myNeighbours[2].equals(this)){
			this.myNeighbours[0].set(this.myNeighbourPoints[0], this.myNeighbours[3], this.myNeighbourPoints[3]);
			this.myNeighbours[3].set(this.myNeighbourPoints[3], this.myNeighbours[0], this.myNeighbourPoints[0]);
			
		} else {
			this.myNeighbours[0].set(this.myNeighbourPoints[0], this.myNeighbours[2], this.myNeighbourPoints[2]);
			this.myNeighbours[2].set(this.myNeighbourPoints[2], this.myNeighbours[0], this.myNeighbourPoints[0]);
			
//			 cjnnect others
			if (this.myNeighbours[3].equals(this)){
				result++;
			} else {
				this.myNeighbours[1].set(this.myNeighbourPoints[1], this.myNeighbours[3], this.myNeighbourPoints[3]);
				this.myNeighbours[3].set(this.myNeighbourPoints[3], this.myNeighbours[1], this.myNeighbourPoints[1]);
				
			}
		}
		
		
		//System.out.println("connect A Type 2 " + this);
		return result;
	}
	
	//  0 + 3  1  2
	public int connectBType(){
		
		int result = 0;
		
		if (this.myNeighbours[0].equals(this)){
			if (this.myNeighbourPoints[0] == 3){
				result++;
				
				if (this.myNeighbours[2].equals(this)){
					result++;
				} else {
					this.myNeighbours[1].set(this.myNeighbourPoints[1], this.myNeighbours[2], this.myNeighbourPoints[2]);
					this.myNeighbours[2].set(this.myNeighbourPoints[2], this.myNeighbours[1], this.myNeighbourPoints[1]);
					
				}
				
				// cjnnect others
			} else if (this.myNeighbours[3].equals(this)){
				result++;
				return result;
			} else {
				this.myNeighbours[1].set(this.myNeighbourPoints[1], this.myNeighbours[3], this.myNeighbourPoints[3]);
				this.myNeighbours[3].set(this.myNeighbourPoints[3], this.myNeighbours[1], this.myNeighbourPoints[1]);
			}
		} else if (this.myNeighbours[3].equals(this)){
			this.myNeighbours[0].set(this.myNeighbourPoints[0], this.myNeighbours[2], this.myNeighbourPoints[2]);
			this.myNeighbours[2].set(this.myNeighbourPoints[2], this.myNeighbours[0], this.myNeighbourPoints[0]);
			
		} else {
			this.myNeighbours[0].set(this.myNeighbourPoints[0], this.myNeighbours[3], this.myNeighbourPoints[3]);
			this.myNeighbours[3].set(this.myNeighbourPoints[3], this.myNeighbours[0], this.myNeighbourPoints[0]);
			
//			 cjnnect others
			if (this.myNeighbours[2].equals(this)){
				result++;
			} else {
				this.myNeighbours[1].set(this.myNeighbourPoints[1], this.myNeighbours[2], this.myNeighbourPoints[2]);
				this.myNeighbours[2].set(this.myNeighbourPoints[2], this.myNeighbours[1], this.myNeighbourPoints[1]);
				
			}
		}
		
		//System.out.println("connect B Type " + this);
		
		/*if (this.myNeighbours[0].equals(this) && this.myNeighbours[1].equals(this)
				&& (this.myNeighbourPoints[2] == 0) && (this.myNeighbourPoints[3] == 1)){
			return 1;
		}
		
		if (this.myNeighbours[0].equals(this) && this.myNeighbours[3].equals(this)
				&& (this.myNeighbourPoints[0] == 3) && (this.myNeighbourPoints[3] == 0)){
			result++;
		}
		
		if (this.myNeighbours[2].equals(this) && this.myNeighbours[1].equals(this)
				&& (this.myNeighbourPoints[2] == 1) && (this.myNeighbourPoints[1] == 2)){
			result++;
		}
		
		this.myNeighbours[0].set(this.myNeighbourPoints[0], this.myNeighbours[3], this.myNeighbourPoints[3]);
		this.myNeighbours[3].set(this.myNeighbourPoints[3], this.myNeighbours[0], this.myNeighbourPoints[0]);
		
		this.myNeighbours[1].set(this.myNeighbourPoints[1], this.myNeighbours[2], this.myNeighbourPoints[2]);
		this.myNeighbours[2].set(this.myNeighbourPoints[2], this.myNeighbours[1], this.myNeighbourPoints[1]);
		*/
		return result;
	}
	
	public void setAsWas(){
		this.myNeighbours[0].set(this.myNeighbourPoints[0], this.myNeighbours[0], this.myNeighbourPoints[0]);
		this.myNeighbours[3].set(this.myNeighbourPoints[3], this.myNeighbours[3], this.myNeighbourPoints[3]);
		
		this.myNeighbours[1].set(this.myNeighbourPoints[1], this.myNeighbours[1], this.myNeighbourPoints[1]);
		this.myNeighbours[2].set(this.myNeighbourPoints[2], this.myNeighbours[2], this.myNeighbourPoints[2]);
		
	}
	
	public String toString(){
		StringBuffer sb = new StringBuffer();
		sb.append(this.myName);
		
		sb.append(" fUp: ");
		sb.append(this.fUpNumber);
		
		sb.append(" sUp: ");
		sb.append(this.sUpNumber);
		
		sb.append(" fDown: ");
		sb.append(this.fDownNumber);
		
		sb.append(" sDown: ");
		sb.append(this.sDownNumber);
		
		for (int i = 0; i < 4; i++){
			sb.append("\n    ");
			if (this.myNeighbours[i] != null){
				sb.append(this.myNeighbours[i].myName);
			} else {
				sb.append("null");
			}
			sb.append(" ");
			sb.append(this.myNeighbourPoints[i]);
		}
		
		sb.append("\n    ");
		sb.append(this.mySignum);
		
		return  sb.toString();
	}

}
